package simFil;
/* UCircRnd.java  ..... an object to store v1,v2,rsq, and facterm where:
	v1 and v2 are a pair of uniformly generated random numbers such that...
	rsq = v1^2 + v2^2 <= 1  (in a unit circle)
	facterm = -4*deltaT*Math.log(rsq)/rsq
	
	Part of a method for generating gaussian distributions of random number taken
	from 'Recipes in C'
*/

/*  <SimFil - simulation of cytoskeletal filament flexibility by Pairwise Agent Interaction with Rational Superposition (PAIRS)>
    Copyright (C) <2008>  <Jonathan B. Alberts>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.Math;

public class UCircRnd {
	double v1,v2,rsq,facterm;
	
	public UCircRnd (double deltaT) {
		newValue(deltaT);
	}
	
	public void newValue (double deltaT) {
		rsq = 0;
		while ((rsq >= 1.0) | (rsq == 0)) {	// while length of vector isn't in the unit circle do..
			v1 = 2*Env.mtRNG.raw()-1;		// one uniform number in the square from -1 to 1...
			v2 = 2*Env.mtRNG.raw()-1;		// ... and another one.
			rsq = v1*v1 + v2*v2;			// length of the vector.
		}
		facterm = -4*deltaT*Math.log(rsq)/rsq;
	}
	
	/*public void newValue (double deltaT) {
		rsq = 0;
		while ((rsq >= 1.0) | (rsq == 0)) {	// while length of vector isn't in the unit circle do..
			v1 = 2*Math.random()-1;		// one uniform number in the square from -1 to 1...
			v2 = 2*Math.random()-1;		// ... and another one.
			rsq = v1*v1 + v2*v2;			// length of the vector.
		}
		facterm = -4*deltaT*Math.log(rsq)/rsq;
	}*/
}
			
